package cz.mendelu.dnaAnalyser.sequence;

import cz.mendelu.dnaAnalyser.utils.exception.NotFoundException;
import cz.mendelu.dnaAnalyser.utils.repository.BaseRepository;
import cz.mendelu.dnaAnalyser.utils.service.ModelService;
import cz.mendelu.dnaAnalyser.sequence.Sequence;
import cz.mendelu.dnaAnalyser.sequence.SequenceRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.UUID;

@Service
public class ModelSequenceService extends ModelService<Sequence> {

    @Autowired
    private SequenceRepository sequenceRepository;

    //@Autowired
    //private SequenceBufferRepository sequenceBufferRepository ;

    //@Autowired
    //private UserRepository userRepository;

    @Override
    protected BaseRepository<Sequence, UUID> getRepository() {
        return sequenceRepository;
    }

    @Override
    public void delete(UUID id) {
        Sequence sequence = sequenceRepository
                .findById(id)
                .orElseThrow(() -> new NotFoundException(Sequence.class, id));
        sequence.setOwner(null);
        sequenceRepository.save(sequence);
    }

    protected String getNcbi(UUID id) {
        String ncbi;
        try {
            ncbi = sequenceRepository.getNcbi(id);
        }
        catch (Exception e) {
            throw new NotFoundException(Sequence.class, id);
        }
        return ncbi;
    }

    protected String getName(UUID id) {
        String name;
        try {
            name = sequenceRepository.getName(id);
        }
        catch (Exception e) {
            throw new NotFoundException(Sequence.class, id);
        }
        return name;
    }

}
