package cz.mendelu.dnaAnalyser.utils.exception;

import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.ResponseStatus;

import java.text.MessageFormat;
import java.util.UUID;

@ResponseStatus(HttpStatus.NOT_FOUND)
public class NotFoundException extends InternalServerException {

    public NotFoundException(String format, Object ... args) {
        super(String.format(format, args));
    }

    public NotFoundException(Class type, UUID id) {
        super(String.format("%s with id: %s not found.", type.getSimpleName(), id));
    }
}
